package com.zoniot.ccrc.commom.utils;

import com.zoniot.ccrc.dto.BuildingSelectDto;
import com.zoniot.ccrc.dto.OrganizationDto;
import com.zoniot.ccrc.entity.Permission;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;

import java.util.List;

import static com.google.common.collect.Lists.newArrayList;

//生成树
public class TreeUtil {

    public static List<Permission> getMenuTree(List<Permission> list, Integer id, Integer leve) {
        List<Permission> temList = newArrayList();
        if (list != null) {
            for (Permission permission : list) {
                if (id.equals(permission.getParentId())) {
                    List<Permission> chidren = getMenuTree(list, permission.getId(), ++leve);
                    Permission temPermission = new Permission();
                    BeanUtils.copyProperties(permission, temPermission);
                    temPermission.setChildren(chidren);
                    temList.add(temPermission);
                    leve--;
                }

            }
        }
        if(temList.size() > 0){
            return temList;
        }else {
            return null;
        }
    }

    /**
     * 获取菜单当前节点的所有父节点id
     */
    public static List<Integer> getParentCategory(List<Permission> permissionsAll, Integer id, List<Integer> newList) {

        for (Permission permission : permissionsAll) {
            // 判断是否存在父节点
            if (permission.getId().equals(id)) {
                // 递归遍历上一级
                getParentCategory(permissionsAll, permission.getParentId(), newList);
                newList.add(permission.getId());
            }
        }
        return newList;
    }


    public static List<OrganizationDto> getOrganTree(List<OrganizationDto> list, Integer id, Integer leve) {
        List<OrganizationDto> temList = newArrayList();
        if (list != null) {
            for (OrganizationDto organizationDto : list) {
                if (id.equals(organizationDto.getParentId())) {
                    List<OrganizationDto> chidren = getOrganTree(list, organizationDto.getId(), ++leve);
                    OrganizationDto temOrganizationDto = new OrganizationDto();
                    BeanUtils.copyProperties(organizationDto, temOrganizationDto);
                    temOrganizationDto.setChildren(chidren);
                    temList.add(temOrganizationDto);
                    leve--;
                }

            }
        }
        if(temList.size() > 0){
            return temList;
        }else {
            return null;
        }
    }
    public static List<OrganizationDto> getOrganList(List<OrganizationDto> list, Integer id, Integer leve,
                                                     List<Integer>ids) {
        List<OrganizationDto> temList = newArrayList();
        if (list != null) {
            for (OrganizationDto organizationDto : list) {
                if (id.equals(organizationDto.getParentId())) {
                    if(organizationDto.getType()==2){
                        ids.add(organizationDto.getId());
                    }
                    List<OrganizationDto> chidren = getOrganList(list, organizationDto.getId(), ++leve,ids);
                    OrganizationDto temOrganizationDto = new OrganizationDto();
                    BeanUtils.copyProperties(organizationDto, temOrganizationDto);
                    temOrganizationDto.setChildren(chidren);
                    temList.add(temOrganizationDto);
                    leve--;
                }

            }
        }
        if(temList.size() > 0){
            return temList;
        }else {
            return null;
        }
    }
    public static List<BuildingSelectDto>  getBuildingSelect(List<BuildingSelectDto> list, Integer id, String dimensionCode, Integer leve) {
        List<BuildingSelectDto> temList = newArrayList();
        if (list != null) {
            for (BuildingSelectDto buildingSelectDto : list) {
                if (id.equals(buildingSelectDto.getPid()) && !StringUtils.equals(dimensionCode,buildingSelectDto.getDimensionCode())) {
                    List<BuildingSelectDto> chidren = getBuildingSelect(list, buildingSelectDto.getCode(), buildingSelectDto.getDimensionCode(), ++leve);
                    BuildingSelectDto tempBuildingSelectDto = new BuildingSelectDto();
                    BeanUtils.copyProperties(buildingSelectDto, tempBuildingSelectDto);
                    tempBuildingSelectDto.setChildren(chidren);
                    temList.add(tempBuildingSelectDto);
                    leve--;
                }
            }
        }
        if(temList.size() > 0){
            return temList;
        }else {
            return null;
        }
    }



}
