package com.zoniot.ccrc.controller.applets;


import com.zoniot.ccrc.commom.model.AjaxMessage;
import com.zoniot.ccrc.commom.model.ResultStatus;
import com.zoniot.ccrc.dto.WarningMessageDto;
import com.zoniot.ccrc.dto.WarningMessageStatusDto;
import com.zoniot.ccrc.service.WarningMessageService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@Slf4j
@Controller
@ResponseBody
@RequestMapping("warningMessage")
@Api( tags = "预警消息")
public class WarningMessageController {

    @Autowired
    private WarningMessageService warningMessageService;




    @ResponseBody
    @GetMapping("/getPage")
    @ApiOperation(value = "预警消息分页")
    public AjaxMessage<List<WarningMessageDto>> getPage(
            @ApiParam(value = "开始日期 格式：yyyyMMdd", required = false) @RequestParam(required = false)  Integer date
            ) {

        List<WarningMessageDto> pageInfo =warningMessageService.getPage(date);
        return new AjaxMessage<>(ResultStatus.OK, pageInfo);
    }


    @ResponseBody
    @GetMapping("/getDateStatus")
    @ApiOperation(value = "预警消息日期状态")
    public AjaxMessage<List<WarningMessageStatusDto>> getDateStatus(
            @ApiParam(value = "日期 格式：yyyyMM", required = true) @RequestParam(required = true) Integer date
            ) {

        List<WarningMessageStatusDto> list = warningMessageService.getDateStatus(date);
        return new AjaxMessage<>(ResultStatus.OK, list);
    }

    @ResponseBody
    @PostMapping("/feedback")
    @ApiOperation(value = "反馈")
    public AjaxMessage feedback(
            @ApiParam(value = "id", required = true) @RequestParam(required = true) Integer id,
            @ApiParam(value = "反馈状态 0：待反馈 1：已确认无异常 2：已反馈信息", required = true) @RequestParam(required = true) Integer feedbackStatus,
            @ApiParam(value = "反馈内容", required = false) @RequestParam(required = false) String feedbackContent
    ){
        warningMessageService.feedback(id,feedbackStatus,feedbackContent);
        return new AjaxMessage<>(ResultStatus.OK);
    }


}
