package com.zoniot.ccrc.dao;

import com.zoniot.ccrc.dto.CommunityDto;
import com.zoniot.ccrc.entity.Community;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface CommunityMapper {
    int insert(@Param("community") Community community);

    int insertSelective(@Param("community") Community community);

    int replaceSelective(@Param("community") Community community);

    int insertList(@Param("communitys") List<Community> communitys);

    int updateByPrimaryKeySelective(@Param("community") Community community);

    List<CommunityDto> findBySiteId(@Param("siteId") Integer siteId, @Param("customerIds") List<Integer> customerIds);

    List<CommunityDto> findByCustomerId(@Param("customerId") Integer customerId);

    List<Community> findByIds(@Param("ids") List<Integer> ids);

    List<CommunityDto> queryList(@Param("param") Community param);

    List<CommunityDto> queryCommunity(@Param("param") Community param, @Param("customerIds") List<Integer> customerIds);

    int findByNameUnique(@Param("siteId") Integer siteId, @Param("id") Integer id, @Param("province") Integer province, @Param("city") Integer city, @Param("region") Integer region, @Param("name") String name);

    List<CommunityDto> getList(@Param("siteId") Integer siteId, @Param("customerId") Integer customerId, @Param("communityName") String communityName, @Param("province") Integer province, @Param("city") Integer city, @Param("region") Integer region);

    Community findByName(@Param("siteId") Integer siteId, @Param("communityName") String communityName);

    Community findByNameV2(@Param("siteId") Integer siteId, @Param("province") Integer province, @Param("city") Integer city, @Param("region") Integer region, @Param("communityName") String communityName);

    Community findById(@Param("id") Integer id);

    List<Community> getBySiteId(@Param("siteId") Integer siteId);

    List<CommunityDto> findCommunityContainBuilding(@Param("siteId") Integer siteId, @Param("name") String name);

    List<Community> getMaxCodeBySiteId(@Param("siteId") Integer siteId);

    List<CommunityDto> getListByCustomerIds(@Param("siteId") Integer siteId, @Param("customerIds") List<Integer> customerIds, @Param("communityName") String communityName, @Param("province") Integer province, @Param("city") Integer city, @Param("region") Integer region);

    List<Community> getOrgCommunity(@Param("orgId") Integer orgId);
}
