package com.zoniot.ccrc.dao;

import com.zoniot.ccrc.dto.OrganizationDto;
import com.zoniot.ccrc.entity.Organization;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface OrganizationMapper {
    int insert(@Param("organization") Organization organization);

    int insertSelective(@Param("organization") Organization organization);

    int insertList(@Param("organizations") List<Organization> organizations);

    int updateByPrimaryKeySelective(@Param("organization") Organization organization);

    List<OrganizationDto> findList(@Param("siteId") Integer siteId);

    List<OrganizationDto> findListForCustomer(@Param("customerId") Integer customerId);

    int findByNameUnique(@Param("id") Integer id, @Param("siteId") Integer siteId, @Param("parentId") Integer parentId, @Param("name") String name);

    Integer countParentId(@Param("id") Integer id);

    List<Organization> findListByIds(@Param("orgIds") Integer[] orgIds);

    List<OrganizationDto> findListByCustomer(@Param("siteId") Integer siteId, @Param("customerId") Integer customerId);

    List<OrganizationDto> fingByOrganizationOne(@Param("siteId") Integer siteId, @Param("customerId") Integer customerId);

    List<OrganizationDto> findListLikeOrgin(@Param("id") Integer id, @Param("siteId") Integer siteId, @Param("customerId") Integer customerId);

    String findOrginName(@Param("id") String id, @Param("siteId") Integer siteId, @Param("customerId") Integer customerId);

    void updateCommutity(@Param("communityIds")List<Integer> communityId, @Param("id")Integer id);

    void deleteCommutityRations(@Param("id") Integer id);
}
