package com.zoniot.ccrc.dao;


import com.zoniot.ccrc.dto.BuildingSelectInfoDto;
import com.zoniot.ccrc.dto.WarningLogDto;
import com.zoniot.ccrc.entity.WarningLog;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.time.LocalDateTime;
import java.util.List;

@Mapper
public interface WarningLogMapper {
    int insertSelective(WarningLog record);

    int updateByPrimaryKeySelective(WarningLog record);

    List<WarningLogDto> getList(
            @Param("siteId") Integer siteId,
            @Param("channelId") Integer channelId,
            @Param("deviceNo") String deviceNo,
            @Param("warningType") Integer warningType,
            @Param("clientName") String clientName,
            @Param("feedbackStatus") Integer feedbackStatus,
            @Param("provinceId") Integer provinceId,
            @Param("cityId") Integer cityId,
            @Param("regionId") Integer regionId,
            @Param("communityId") Integer communityId,
            @Param("buildingId") Integer buildingId,
            @Param("startDate") LocalDateTime startDate,
            @Param("endDate") LocalDateTime endDate);

    List<BuildingSelectInfoDto> getAreaList(
            @Param("siteId") Integer siteId,
            @Param("channelId") Integer channelId,
            @Param("deviceNo") String deviceNo,
            @Param("warningType") Integer warningType,
            @Param("clientName") String clientName,
            @Param("feedbackStatus") Integer feedbackStatus,
            @Param("startDate") LocalDateTime startDate,
            @Param("endDate") LocalDateTime endDate);

}