package com.zoniot.ccrc.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

@Data
public class BuildingInfoListDto implements Serializable {

    private static final long serialVersionUID = -7349239278001071116L;

    @ApiModelProperty(value = "建筑id", position = 1)
    private Integer buildingId;

    @ApiModelProperty(value = "建筑名称", position = 2)
    private String buildingName;

    @ApiModelProperty(value = "建筑地址", position = 3)
    private String address;

    @ApiModelProperty(value = "消防安全责任人", position = 4)
    private String fireRespName;

    @ApiModelProperty(value = "消防安全责任人电话", position = 5)
    private String fireRespPhone;

    @ApiModelProperty(value = "正常数", position = 8)
    private Integer normalCount = 0;

    @ApiModelProperty(value = "告警数", position = 6)
    private Integer alarmCount = 0;

    @ApiModelProperty(value = "故障数", position = 7)
    private Integer faultCount = 0;

    @ApiModelProperty(value = "预警设备数", position = 8)
    private Integer offlineCount = 0;

    @ApiModelProperty(value = "未启用设备数", position = 8)
    private Integer deviceUnusedCount = 0;

    @ApiModelProperty(value = "设备数", position = 8)
    private Integer deviceCount = 0;

    @ApiModelProperty(value = "省", position = 9)
    private String provinceName;

    @ApiModelProperty(value = "市", position = 10)
    private String cityName;

    @ApiModelProperty(value = "区", position = 11)
    private String regionName;

    @ApiModelProperty(value = "小区", position = 12)
    private String communityName;

    @ApiModelProperty(value = "经度", position = 18)
    private String longitude;

    @ApiModelProperty(value = "纬度", position = 19)
    private String latitude;

    @ApiModelProperty(value = "省", position = 20)
    private Integer province;

    @ApiModelProperty(value = "市", position = 21)
    private Integer city;

    @ApiModelProperty(value = "区", position = 22)
    private Integer region;

    @ApiModelProperty(value = "小区", position = 23)
    private Integer community;
}
