package com.zoniot.ccrc.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

@Data
@ApiModel("站点")
public class Site implements Serializable {
    private static final long serialVersionUID = 891681648912370218L;
    @ApiModelProperty(value = "id", position = 1)
    private Integer id;

    @ApiModelProperty(value = "名称", position = 2)
    private String name;

    @ApiModelProperty(value = "域名", position = 3)
    private String website;

    @ApiModelProperty(value = "logo", position = 4)
    private String logoUrl;

    @ApiModelProperty(value = "站点类型 1：默认", position = 5)
    private Integer type;

    @ApiModelProperty(value = "客户id", position = 5)
    private Integer customerId;

    @ApiModelProperty(value = "客户名称", position = 6)
    private String customerName;

    @ApiModelProperty(value = "账号", position = 6)
    private String account;

    @ApiModelProperty(value = "状态", position = 7, hidden = true)
    private Integer status;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间", position = 50, hidden = true)
    private LocalDateTime createDate;

    @ApiModelProperty(value = "创建人", position = 51, hidden = true)
    private String createBy;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "更新时间", position = 52, hidden = true)
    private LocalDateTime updateDate;

    @ApiModelProperty(value = "更新人", position = 53, hidden = true)
    private String updateBy;


}
