package com.zoniot.ccrc.service.impl;

import com.github.pagehelper.PageHelper;
import com.zoniot.ccrc.commom.model.Pagination;
import com.zoniot.ccrc.commom.utils.UserUtil;
import com.zoniot.ccrc.dao.MessageMapper;
import com.zoniot.ccrc.dto.LoginUser;
import com.zoniot.ccrc.entity.Message;
import com.zoniot.ccrc.service.MessageService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.time.LocalDateTime;
import java.util.List;

@Service
public class MessageServiceImpl implements MessageService {

    @Resource
    private MessageMapper messageMapper;

    @Override
    public int insertSelective(Message record) {
        record.setStatus(1);
        record.setDateCreate(LocalDateTime.now());
        record.setCreateBy("system");
        record.setDateUpdate(LocalDateTime.now());
        record.setUpdateBy("system");
        return messageMapper.insertSelective(record);
    }

    @Override
    public int updateByPrimaryKeySelective(Message record) {
        record.setDateUpdate(LocalDateTime.now());
        return messageMapper.updateByPrimaryKeySelective(record);
    }

    @Override
    public int batchInsert(List<Message> list) {
        return messageMapper.batchInsert(list);
    }

    @Override
    public Pagination<Message> getMessageList(Integer read, int pageNum, int pageSize) {
        LoginUser loginUser = UserUtil.getCurrentUser();
        PageHelper.startPage(pageNum, pageSize);
        List<Message> list = messageMapper.getList(loginUser.getId(), read);
        return new Pagination<>(list);
    }

    @Override
    public Integer getMessageCount() {
        LoginUser loginUser = UserUtil.getCurrentUser();
        return messageMapper.getMessageCount(loginUser.getId());
    }

    @Override
    public void delMessage(List<Integer> ids) {
        messageMapper.delMessage(ids);
    }

    @Override
    public void markRead(List<Integer> ids) {
        messageMapper.markRead(ids);
    }
}

