package com.zoniot.ccrc.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.PageHelper;
import com.zoniot.ccrc.commom.model.Pagination;
import com.zoniot.ccrc.commom.utils.UserUtil;
import com.zoniot.ccrc.dao.WarningLogMapper;
import com.zoniot.ccrc.dao.WarningRuleMapper;
import com.zoniot.ccrc.dto.BuildingSelectDto;
import com.zoniot.ccrc.dto.BuildingSelectInfoDto;
import com.zoniot.ccrc.dto.LoginUser;
import com.zoniot.ccrc.dto.WarningLogDto;
import com.zoniot.ccrc.entity.WarningLog;
import com.zoniot.ccrc.service.BuildingService;
import com.zoniot.ccrc.service.WarningLogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import javax.annotation.Resource;
import java.time.LocalDateTime;
import java.util.*;

@Service
public class WarningLogServiceImpl implements WarningLogService {

    @Resource
    private WarningLogMapper warningLogMapper;
    @Resource
    private WarningRuleMapper warningRuleMapper;

    @Autowired
    private BuildingService buildingService;



    @Override
    public int insertSelective(WarningLog record) {
        return warningLogMapper.insertSelective(record);
    }

    @Override
    public int updateByPrimaryKeySelective(WarningLog record) {
        return warningLogMapper.updateByPrimaryKeySelective(record);
    }

    @Override
    public Pagination<WarningLogDto> getList(Integer channelId, String deviceNo, Integer warningType, String clientName, Integer feedbackStatus, Integer provinceId, Integer cityId, Integer regionId, Integer communityId, Integer buildingId, LocalDateTime startDate, LocalDateTime endDate, int pageNum, int pageSize) {
        LoginUser loginUser = UserUtil.getCurrentUser();
        PageHelper.startPage(pageNum,pageSize);
        List<WarningLogDto> list =  warningLogMapper.getList(loginUser.getSiteId(),channelId,deviceNo,warningType,clientName,feedbackStatus,provinceId,cityId,regionId,communityId,buildingId,startDate,endDate);

        return new Pagination<>(list);
    }
    private String sendApiReQuest(String path , String args){
        HttpHeaders headers = new HttpHeaders();
        headers.setContentType(MediaType.APPLICATION_JSON);
        HttpEntity<String> formEntity = new HttpEntity<>(args, headers);

        RestTemplate restTemplate=new RestTemplate();
        ResponseEntity<String> stringResponseEntity = restTemplate.postForEntity(path, formEntity,
                String.class);
        JSONObject info = JSONObject.parseObject(stringResponseEntity.getBody());
        String result=null;
        if(info.getInteger("status")==0){
            result=info.getString("data");
        }
        return result;
    }

    @Override
    public List<BuildingSelectDto> getAreaList(Integer channelId, String deviceNo, Integer warningType, String clientName, Integer feedbackStatus, LocalDateTime startDate, LocalDateTime endDate) {
        LoginUser loginUser = UserUtil.getCurrentUser();
        List<BuildingSelectInfoDto> buildingList = warningLogMapper.getAreaList(loginUser.getSiteId(),channelId,deviceNo,warningType,clientName,feedbackStatus,startDate,endDate);
        return buildingService.areaList(buildingList);
    }
}
