package com.zoniot.ccrc.service.impl;


import com.zoniot.ccrc.commom.utils.UserUtil;
import com.zoniot.ccrc.dao.WarningLogMapper;
import com.zoniot.ccrc.dao.WarningMessageMapper;
import com.zoniot.ccrc.dto.LoginUser;
import com.zoniot.ccrc.dto.WarningMessageDto;
import com.zoniot.ccrc.dto.WarningMessageStatusDto;
import com.zoniot.ccrc.entity.WarningLog;
import com.zoniot.ccrc.entity.WarningMessage;
import com.zoniot.ccrc.service.WarningMessageService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.time.LocalDateTime;
import java.util.List;

@Service
public class WarningMessageServiceImpl implements WarningMessageService {

    @Resource
    private WarningMessageMapper warningMessageMapper;
    @Resource
    private WarningLogMapper warningLogMapper;


    @Override
    public int insertSelective(WarningMessage record) {
        return warningMessageMapper.insertSelective(record);
    }

    @Override
    public int updateByPrimaryKeySelective(WarningMessage record) {
        return warningMessageMapper.updateByPrimaryKeySelective(record);
    }

    @Override
    public int batchInsert(List<WarningMessage> list) {
        return warningMessageMapper.batchInsert(list);
    }

    @Override
    public List<WarningMessageDto> getPage(Integer date) {
       return null;//warningMessageMapper.getList(deviceDto.getDeviceId(), date);
    }

    @Override
    public List<WarningMessageStatusDto> getDateStatus(Integer date) {
        return null;//warningMessageMapper.getDateStatus(deviceDto.getDeviceId(), date);
    }

    @Override
    public void feedback(Integer id, Integer feedbackStatus, String feedbackContent) {
        LoginUser loginClientUser = UserUtil.getCurrentUser();
        WarningMessage warningMessage = warningMessageMapper.findById(id);

        WarningLog warningLog = new WarningLog();
        warningLog.setId(warningMessage.getWarningLogId());
        warningLog.setFeedbackStatus(feedbackStatus);
        warningLog.setFeedbackContent(feedbackContent);
        warningLog.setUpdateBy(loginClientUser.getUsername());
        warningLog.setDateUpdate(LocalDateTime.now());
        warningLogMapper.updateByPrimaryKeySelective(warningLog);
    }
}



